local version_required = 'nvim-0.8.0'
-- 0.7.0 features we need:
--   - autocommands in Lua
--   - bind key mappings directly to Lua functions
--   - desc in keymaps
-- 0.8.0 features we need:
--   - dunno, needed for lazy.nvim
--   - CursorHold fix
if vim.fn.has(version_required) == 0 then
    print("💥 need " .. version_required .. ", config files will NOT be read!")
    return nil
end

-- use the vim plugins installed via the OS package manager
if vim.fn.isdirectory('/usr/share/vim/vimfiles') == 1 then
    vim.opt.runtimepath:append('/usr/share/vim/vimfiles')
end

require('my/early')
require('my.functions')
require('my/lazy')
require('my/options')
require ('my/keybindings')
require('my/filetypes')
require('my/git')
